<template>
	<li role="group" :class="$style.slide" :aria-hidden="ariaHidden" :aria-label="ariaLabel">
		<slot v-bind="{ isSlideActive: !ariaHidden }" />
	</li>
</template>

<script>
export default {
	props: {
		title: {
			type: String,
			default: null,
		},

		slideIndex: {
			type: Number,
			required: true,
		},

		hiddenOverride: {
			type: Boolean,
			default: null,
		},
	},

	computed: {
		ariaHidden() {
			const { hiddenOverride } = this;

			return hiddenOverride !== null
				? String(hiddenOverride)
				: String(this.$parent.$data.currentSlide !== this.slideIndex);
		},

		ariaLabel() {
			if (this.title) {
				return `Slide ${this.slideIndex + 1}: ${this.title}`;
			}

			return `Slide ${this.slideIndex + 1} of ${this.$parent.$data.numberOfSlides}.`;
		},
	},

	created() {
		this.$parent.getSlideTitle(this.title);
	},
};
</script>

<style lang="scss" module>
@import '@design';

.slide {
	position: relative;
	flex: 1 0 100%;
}
</style>
